// readbmp.cpp : Defines the entry point for the console application.   
//   

#include <string>
#include <iostream>

#include <cv.h>
#include <highgui.h>

//#include "stdafx.h"   
//#include <iostream .h>   
//   
//#include "ipl.h"   
//#include "cv.h"   
////#include "_cv.h"   
////#include "vlgrfmts.h"   
   
//-----------------------------   
////////UTILITY FUNCTIONS   
//   
// Read in a BMP and convert it into an IPL   
// fin The file name of the BMP with path   
// plannar If set, convert the image to plannar   
// flip If set, mirror the image around the horizontal axis, set   
// IPL_ORIGIN_BL)   
//IplImage * readBMP2IPL(char *fin, int plannar = 0, int flip = 0)   
//{   
//    int filter;   
//    int width=0,height=0,color=55,hdr_ret=0,close_ret = 0,rd_ret = 0;   
//    IplImage *I;   
//    filter = gr_fmt_find_filter(fin ); //Get file type   
//    hdr_ret = gr_fmt_read_header( filter, &width, &height, &color );//image params   
//    I = cvCreateImageHeader( cvSize(width, height), IPL_DEPTH_8U, 3); //create image header   
//    I->align = IPL_ALIGN_QWORD; //fix the problem that cvCreateImage uses align 4   
//    I->depth != IPL_DEPTH_32F ? iplAllocateImage( I, 0, 0 ) :iplAllocateImageFP( I, 0, 0 );   
//    rd_ret = gr_fmt_read_data(filter, I->imageData, I->widthStep, color); //read in the data, origin TL   
//    close_ret = gr_fmt_close_filter( filter );   
//    if(plannar) //If plannar order desired, turn it into plannar order   
//    {   
//        IplImage *Ip = iplCreateImageHeader(3, 0, IPL_DEPTH_8U, "RGB","BGR", IPL_DATA_ORDER_PLANE, I->origin, IPL_ALIGN_QWORD, width, height, NULL,NULL,NULL,NULL);   
//        iplAllocateImage(Ip, 0,0);   
//        iplConvert(I,Ip);   
//        cvReleaseImage( &I );   
//        I = Ip;    
//    }   
//    if(flip) //User wants IPL_ORIGIN_BL   
//    {   
//        iplMirror(I, I, 0); //flipporuni   
//        I->origin = IPL_ORIGIN_BL;   
//    }   
//    return I;   
//}   
//   
////////////////////////////////////////////   
//// Write IPL image to disk as a BMP image (not optimized but step by step simplistic)   
//// fout Path\filename to write to   
//// I IPL image to be written   
////   
//// Image fomat may be any of:   
//// dataOrder Plane or Pixel   
//// 1 channel (GRAY) or 3 (RGB)   
//// 8U, 8S, 32F   
//// Origin TL or BL (if BL, image is flipped to conform to TL bmps)   
////   
//// If image is not RGB or GRAY, RGB is simply imposed on the Image. E.g. if it's YUV,   
//// the image will be stored as BGR with B=Y, G=U, and R=V   
//void writeIPL2BMP(char *fout, IplImage *I)   
//{   
//    IplImage *Isav,*Itmp;   
//    Isav = iplCloneImage(I);   
//    //Convert to pixel order if needed   
//    if(I->dataOrder == IPL_DATA_ORDER_PLANE)   
//    {   
//        Itmp = iplCreateImageHeader(I->nChannels,   
//            I->alphaChannel, I->depth, I->colorModel,   
//            I->channelSeq, IPL_DATA_ORDER_PIXEL, I->origin,   
//            I->align,   
//            I->width, I->height, NULL, NULL,NULL,NULL);   
//        if(I->depth == IPL_DEPTH_32F)   
//            iplAllocateImageFP(Itmp, 1,0.0);   
//        else   
//            iplAllocateImage(Itmp, 1,0);   
//        iplConvert(I, Itmp);   
//        iplDeallocate (I, IPL_IMAGE_ALL);   
//        I = Itmp;   
//    }   
//    //Image is now pixel order. Convert to 8U if needed.   
//    if(I->depth == IPL_DEPTH_8S)   
//        I->depth = IPL_DEPTH_8U;   
//    else if(I->depth == IPL_DEPTH_32F)   
//    {    
//        float min,max;   
//        iplMinMaxFP (I, &min, &max);   
//        Itmp = iplCreateImageHeader(I->nChannels,   
//            I->alphaChannel, IPL_DEPTH_8U, I->colorModel,   
//            I->channelSeq, IPL_DATA_ORDER_PIXEL, I->origin,   
//            I->align,   
//            I->width, I->height, NULL, NULL,NULL,NULL);   
//        iplAllocateImage(Itmp, 1,0);   
//        if(min >= max) max = (float)(min + 1.0);   
//        iplScaleFP (I, Itmp, min, max);   
//        iplDeallocate (I, IPL_IMAGE_ALL);   
//        I = Itmp;   
//    }   
//    //Image is now pixel order, 8U. Convert to RGB if needed   
//    if(I->nChannels == 3)   
//    {   
//        strcpy(I->colorModel,"RGB");   
//        strcpy(I->channelSeq,"BGR");   
//    }   
//    else if(I->nChannels == 1)   
//    {   
//        Itmp = iplCreateImageHeader(3,   
//            I->alphaChannel, IPL_DEPTH_8U, "RGB",   
//            "BGR", IPL_DATA_ORDER_PIXEL, I->origin, I->align,   
//            I->width, I->height, NULL, NULL,NULL,NULL);   
//        iplAllocateImage(Itmp, 1,0);   
//        iplGrayToColor (I, Itmp, 1.0, 1.0, 1.0);   
//        iplDeallocate (I, IPL_IMAGE_ALL);   
//        I = Itmp;   
//    }   
//    else   
//        return;   
//    //Image is now pixel order, 8U, RGB, flip it if the origin is BL   
//    if(I->origin == IPL_ORIGIN_BL)   
//    {   
//        iplMirror(I, I, 0);   
//    }   
//    //FINALLY, WRITE THE IMAGE:   
//    int write_ret = gr_fmt_write_image( I->imageData, I->widthStep,    
//        I->width, I->height, I->colorModel[0] =='R'?1:0,fout, "bmp");   
//    //Return image to its original state   
//    iplDeallocate(I, IPL_IMAGE_ALL);   
//    I = Isav;   
//}   
   
//-----------------------------   
   
//void main()   
int main( int argc, const char * argv[] )
{   
    //IplImage * input_img=NULL;   
    //int plannar=0;   
    //int flip=0;   
    //char fin[]="circles.bmp";   
    //char fout[]="result.bmp";   
  
    IplImage *input_img,*pimg;

    input_img=cvLoadImage( argv[1], CV_LOAD_IMAGE_UNCHANGED );

    CvMemStorage *storage;   
    int header_size, i, count,length, width;   
    CvSeq *contour;   
    CvBox2D * myBox;
    CvPoint *PointArray;   
    CvPoint2D32f *PointArray32f;   
    CvPoint myCenter;   
       
    myBox= (CvBox2D *) malloc(sizeof(CvBox2D));   
    header_size = sizeof(CvContour);   
    storage = cvCreateMemStorage (1000);
       
//    input_img=readBMP2IPL(fin,plannar, flip);   
   
    std::cout<<" The following is the attribute for current image:\n";   
    std::cout<<"Num of channels: "<< input_img->nChannels<<"\n" ;
    std::cout<<"depth: "<<input_img->depth<<"\n";
    std::cout<<"Color mode: "<<input_img->colorModel<<"\n";
    std::cout<<"Channel Seq: "<<input_img->channelSeq<<"\n" ;
    std::cout<<"DataOrder: "<<input_img->dataOrder<<"\n" ;
    std::cout<<"Origin (top-left /bottom left): "<<input_img->origin<<"\n" ; 
    std::cout<<"Width : "<<input_img->width<<"\n" ; 
    std::cout<<"Height : "<<input_img->height<<"\n" ;

    //int w=input_img->width;   
    //int h = input_img->height;   
    //IplImage* m_tmp8uC1= cvCreateImage(   
    //    cvSize(w ,h ),      
    //    IPL_DEPTH_8U,1);
    //   
    //IplImage* m_tmp8uC3= cvCreateImage(                             
    //    cvSize( w ,h),     
    //    IPL_DEPTH_8U,3);
    //   
    //   
    //iplBlur(input_img,m_tmp8uC3, 2,2,1,1);   
    //   
    //iplColorToGray(m_tmp8uC3, m_tmp8uC1);   
    //   
    //cvReleaseImage(&m_tmp8uC3);   
       
    //int number_of_c=cvFindContours (m_tmp8uC1 , storage, &contour, header_size, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_SIMPLE);   
    //int number_of_c=cvFindContours (input_img , storage, &contour, header_size, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_SIMPLE);   
    int number_of_c=cvFindContours (input_img , storage, &contour, header_size, CV_RETR_LIST, CV_CHAIN_APPROX_NONE);   

    std::cout<<"number of contours: "<<number_of_c <<"\n";
    
    while(contour!=NULL) //contourΪʱ 
    {
      //if(CV_IS_SEQ_CURVE(contour)){
        //#define CV_IS_SEQ_CURVE(seq)\(CV_GET_SEQ_KIND(seq)== CV_SEQ_KIND_CURVE) 
      count=contour->total;

            PointArray = (CvPoint *)malloc(count * sizeof(CvPoint));   
               
            //COPY THE POINTS TO A ARRAY   
            cvCvtSeqToArray(contour, PointArray, CV_WHOLE_SEQ);   
               
            // ALLOC MEM   
            PointArray32f = (CvPoint2D32f *)   
                malloc((count + 1) * sizeof(CvPoint2D32f));   
               
            //CONVERT THE ARRAY TO A 2ND (32FLOAT)   
            for (i=0; i<count-1 ; i++) 
            {
              PointArray32f[i].x=(float)(PointArray[i].x);
              PointArray32f[i].y=(float)(PointArray[i].y);
            }
              PointArray32f[i].x=(float)(PointArray[0].x); 
              PointArray32f[i].y=(float)(PointArray[0].y);
              //FOR DEBUGGING YOU CAN DRAW THE CONTOUR 
              //cvDrawContours(input_img,contour,CV_RGB(0,0,255),CV_RGB(0,255,0),1,1);// IS IT ? if (count>=7) 
            //    cvSaveImage( argv[2], input_img );
            //{   
                //FIND THE BEST FITTING ELLIPSE IN THIS CONTOUR   
                //std::cout << "count: " << count << "\n";
              if(75<count && count<150 )
//                if(count>=7)
                {
              cvFitEllipse(PointArray32f, count,myBox);   
                   
   
                //CENTER   
                myCenter.x = (int) myBox->center.x;   
                myCenter.y = (int) myBox->center.y;   
                   
                //HEIGHT AND WITH (THE 2 AXES OF THE ELLIPSE)   
                length  =(int)myBox->size.height;   
                width = (int)myBox->size.width;   
                   
                //AND THE ANGLE   
                float myAngle= myBox->angle;   
                   
                if ((myCenter.x > 0) && (myCenter.y >0))   
                {         
                    cvCircle(input_img,myCenter,(int)length/2 ,CV_RGB(255,0,0),1);   
                       
                    cvEllipse(input_img,   
                        myCenter,   
                        cvSize ((int)width/2,(int)length/2) ,   
                        myBox->angle,   
                        0,360,CV_RGB(255,0,255),1);   
                }   
                   
            }   
            free(PointArray32f );   
            free(PointArray );   
        //}   
        // GOT TO THE NEXT CONTOUR (IF ANY)   
        contour = contour->h_next;   
    }   
                   
                   
    free(contour);   
    free(myBox);               
 //   cvReleaseImage(&m_tmp8uC1);   
    cvReleaseMemStorage(&storage);   

  cvSaveImage( argv[2], input_img );

  //if(img) cvReleaseImage(&img);
  //if(pimg) cvReleaseImage(&pimg);

  return 0;

    //writeIPL2BMP(fout,input_img);//Ѷ   char fout[]="result.bmp";   
                   
}