<?php 
/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

//enum of usertypes
$enum_admin = 0;
$enum_user = 1;
$enum_guest = 2;

$u_ua = false;
$u_uu = false;
$u_ug = false;

$u_up = false;

if (!isset($_SESSION["authenticated"]))
{ 
  echo "<script>location.href=\"index.php?erroruser\";</script>";
}
else
{
  //set usertype
  if ($_SESSION['usertype'] == $enum_admin) $u_ua = true;
  if ($_SESSION['usertype'] == $enum_user)  $u_uu = true;
  if ($_SESSION['usertype'] == $enum_guest) $u_ug = true;
    
  if (($_SESSION['usertype'] == $enum_admin) || ($_SESSION['usertype'] == $enum_user)) $u_up = true;
  
}  
?>
