<?php 

/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

$db_username="PUT_YOUR_DB_USERNAME_HERE";
$db_password="PUT_YOUR_DB_PASSWORD_HERE";

$gmapsApiKey = "PUT_YOUR_GMAPS_API_KEY_HERE";

$db_server="localhost";
$db_name = "cip2";
$localDocumentRoot = "/var/www/html/cip2";

$localCodeRoot = $localDocumentRoot;

$pathCodeOwn = "$localCodeRoot/CervixAlgorithms-Build/";
$pathCodeVipsIo = "$localCodeRoot/VipsRegionIO/";  

$serverName = "localhost";
  
$pathCodeItk = "$localCodeRoot/CervixAlgorithms-Build/";


$pathCodeImagemagick = "/usr/bin/";

$pathSlideDataServer = "http://$serverName/cip2/virtualmicroscope/";

$pathCodePhpScripts = "$localDocumentRoot/website/scripts/";

$pathSlideData = "$localDocumentRoot/virtualmicroscope/";
$pathIncomingFiles = "$localDocumentRoot/incoming_svs_files/";
$pathIncomingCollections = "$localDocumentRoot/incoming_work_collections/";


$postfixFullSlide = "_full.tif";
$postfixThumbnail = "_thumbnail.jpg";
$postfixCode = "_code.jpg";

$filenameRegions = "computedRegions.txt";
$filenameExportedRegions = "exportedRegions.txt";

$filenameRegionsOtsuImage = "roiComputationOtsu.png";

$executableExtension = "";
$separator = "/";
$separatorNot = "\\";

//the enum for the regions. This has to be the same as in cip_frontend.js
$enum_regionDeleted = -1;
$enum_regionAutomatic = 0;
$enum_regionConfirmed = 1;
$enum_regionManual = 2;

?>
