<?php 
  session_start();  

/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

  require("auth_and_connect.php");
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Add specimen</title>
<link href="css/css_base.css" rel="stylesheet" type="text/css" />

<script type="text/javascript" src="js/prototype/prototype.js"></script>
<script type="text/javascript" src="js/bramus/jsProgressBarHandler.js"></script>

</head>
<body>
<div id="container">
	<?php include("header.php"); ?>
	<div id="inner_container">
    <div id="page_title">
       	  <h1>Start nuclei finding</h1>
            <div style="clear:both"></div>	
            <hr />
      </div>
    <div id="sidebar">
        <ul><h3>
              <li ><a title="Back" href="gui_image_viewer.php?id=<?php echo $_GET['id_specimen'] ?>">Back</a></li>
        </h3></ul>
	</div>      
	<div id="content">   
  

<?php

function ends_with($string, $endstr)
{
    $string_end = substr($string, strlen($string) - strlen($endstr));
    //return $string_end == $endstr;
    return (strncmp($string_end, $endstr, strlen($endstr)) == 0);
}

  $idSpecimenSubmitted = $_GET['id_specimen'];
  
  $manual = $_GET['manual'];
  $auto = $_GET['auto'];
  $confirmed = $_GET['confirmed'];
  
  $results = mysql_query("select * from specimen where id=$idSpecimenSubmitted order by id");
  $row = @ mysql_fetch_array($results);
  
  $nameSpecimen = $row["name"];
  $idSpecimen = $row["id"];
  $pathSpecimen = $row["path"];

  //-------------------------------------------
  //if the test_collection not already exists, add it. Until now, everything will be put into this collection, 
  //as so far no proper collection handling is implemented
     
  $idWorkCollection = -1;
  $nameWorkCollection = "Tests";
  $pathWorkCollection = "test_collection/";
  
  $results = mysql_query("select * from work_collections where name='$nameWorkCollection' AND id_specimen=$idSpecimen order by id");
  
  $collectionExists = @ mysql_num_rows($results);
  
  if (!($collectionExists > 0))
  {
    $query = "INSERT INTO work_collections(id, id_specimen, name, date, comment, path) VALUES (NULL , $idSpecimen, '$nameWorkCollection', '" . 
                                                              date('Y-m-d') . "', '', '$pathWorkCollection')";
    //print $query."</br>";
    $result=mysql_query($query);
    if(mysql_errno($connection)==0)
    {
      print "Dataset was inserted</br>";
    }
    else
    {
      if(mysql_errno($connection)==1062)
        print "Double primary key, couldn't insert</br>";
      else
      {
        $numERROR=mysql_errno($connection);
        $description=mysql_errno($connection);
        print "An error occured: $numERROR Description: $description </br>";
      };
    } 
    
    $idWorkCollection = mysql_insert_id();
    
  }
  else
  {
    $row = @ mysql_fetch_array($results); 
    $idWorkCollection = $row["id"];
    $pathWorkCollection= $row["path"];
  }

  //-------------------------------------------
  
    
if (isset($_POST["process"]))
{

  $filterName = "ATh";
  $filterPath = "ATh/";  
  
  $results = mysql_query("select * from regions where id_specimen=$idSpecimen order by id");

  $pathWorkCollections = "$pathSlideData$pathSpecimen/work_collections/";
  $pathCurrentWorkCollection = "$pathWorkCollections$pathWorkCollection";
    
  shell_exec(str_replace($separatorNot, $separator, "mkdir $pathWorkCollections"));
  shell_exec(str_replace($separatorNot, $separator, "mkdir $pathCurrentWorkCollection"));

  $regionFileUrl = "$pathSlideData$pathSpecimen/work_collections/$pathWorkCollection$filenameExportedRegions";
  //$tmpRegionFileUrl = "$pathSlideData$filenameExportedRegions";
    
  $fh = fopen($regionFileUrl, 'w') or die("can't open region file for writing..");
    
  while ($row = @ mysql_fetch_array($results)) 
  {
    
    if((($row["state"] == $enum_regionAutomatic) && ($auto == "1")) ||
       (($row["state"] == $enum_regionConfirmed) && ($confirmed == "1")) ||
       (($row["state"] == $enum_regionManual) && ($manual == "1"))) 
    {
      $stringData = $row["id"]." ".$row["x"]." ".$row["y"]." ".$row["size_x"]." ".$row["size_y"]." ".$row["lat"]." ".$row["lng"]."\n";
      fwrite($fh, $stringData);
    }  
  }
    
  fclose($fh);
  
  echo "processing files started..</br>";
  shell_exec("php scripts/phpsql_find_nuclei_in_rois.php $idSpecimen $pathSpecimen $idWorkCollection $pathWorkCollection $filterName $filterPath > $localDocumentRoot/log/log_find_nuclei_spec_$idSpecimen.txt &");
}  
else
{

  $state = -2;
  $stateFileName = "$pathSlideData$pathSpecimen/work_collections/$pathWorkCollection.state";
  $stateFileHandle = fopen($stateFileName, "r");
  
  if($stateFileHandle)
  {
    $stateFileContent = fread($stateFileHandle, filesize($stateFileName));
    fclose($stateFileHandle);
    
    $state = $stateFileContent + 0;
  }
  else
  {
    $fh = fopen($stateFileName, 'w');
    fwrite($fh, "-1"); 
    fclose($fh);
    $state = -1;
  }




  if($state == -1)
  {   

    ?>
      
    <div id="form" align="center">
      <form action="" method="post" enctype="multipart/form-data" name="form1" id="form1">
        <input type="submit" name="process" id="process" value="Regions have been exported. Click to start processing.." />
      </form>
    </div>
      
    <?php
  
    $results = mysql_query("select * from regions where id_specimen=$idSpecimen order by id");
    
    print "Regions that will be used for computation:<br/><br/>";
    
    while ($row = @ mysql_fetch_array($results)) 
    {
      
      if((($row["state"] == $enum_regionAutomatic) && ($auto == "1")) ||
         (($row["state"] == $enum_regionConfirmed) && ($confirmed == "1")) ||
         (($row["state"] == $enum_regionManual) && ($manual == "1"))) 
      {
        $stringData = $row["id"]." ".$row["x"]." ".$row["y"]." ".$row["size_x"]." ".$row["size_y"]." ".$row["lat"]." ".$row["lng"]."\n";
        print $stringData."<br/>";  
      }  
    }
  }
  else if(($state >= 0) && ($state <= 100))
  {
    echo "Operation yet in progress:</br>\n";
    echo "<span class=\"progressBar\" id=\"progress_find_nuclei\">$state%</span>";
  }
  else 
  {
    echo "Something went wrong..state could not be determined</br>\n";
  }
  
}
?>

</div>
</div>
</div>
</body>
</html>
