

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

CREATE DATABASE cip2;

USE cip2;

CREATE TABLE `regions` (
  `id` int(11) NOT NULL auto_increment,
  `id_specimen` int(11) NOT NULL,
  `state` int(11) NOT NULL DEFAULT 0,
  `x` int(11) NOT NULL DEFAULT 0,
  `y` int(11) NOT NULL DEFAULT 0,
  `size_x` int(11) NOT NULL DEFAULT 0,
  `size_y` int(11) NOT NULL DEFAULT 0,
  `lat` FLOAT( 10, 6 ) NOT NULL DEFAULT 0,
  `lng` FLOAT( 10, 6 ) NOT NULL DEFAULT 0,
  `id_user` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE `filter_results` (
  `id` int(11) NOT NULL auto_increment,
  `id_work_collection` int(11) NOT NULL,
  `name` varchar(45) NOT NULL,
  `date` date NOT NULL,
  `comment` varchar(300) NOT NULL,
  `path` varchar(200) NOT NULL,
  `parameters` varchar(45) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE `work_collections` (
  `id` int(11) NOT NULL auto_increment,
  `id_specimen` int(11) NOT NULL,
  `name` varchar(45) NOT NULL,
  `date` date NOT NULL,
  `comment` varchar(300) NOT NULL,
  `path` varchar(200) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE `specimen` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(45) NOT NULL,
  `date` date NOT NULL,
  `comment` varchar(200) NOT NULL,
  `path` varchar(200) NOT NULL,
  `size_x` int(11) NOT NULL,
  `size_y` int(11) NOT NULL,
  `roi_finding_param1` FLOAT( 10, 6 ) NOT NULL,
  `roi_finding_param2` FLOAT( 10, 6 ) NOT NULL,
  `roi_finding_param3` FLOAT( 10, 6 ) NOT NULL,
  `roi_finding_param4` FLOAT( 10, 6 ) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE `users` (
  `id` int(11) NOT NULL auto_increment,
  `username` varchar(45) NOT NULL,
  `password` blob NOT NULL,
  `usertype` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
