<?php 
session_start(); 

/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/
 
require("auth_and_connect.php");
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Specimen viewer</title>
<link href="css/css_base.css" rel="stylesheet" type="text/css" />



<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;sensor=false&amp;key=<?php echo $gmapsApiKey ?>" type="text/javascript"></script>
<script type="text/javascript" src="js/map_utilities.js"></script>
<script type="text/javascript" src="js/cip_backend.js"></script>
<script type="text/javascript" src="js/cip_frontend.js"></script>

</head>
<?php

//    <script type='text/javascript' 
//            src='http://getfirebug.com/releases/lite/1.2/firebug-lite-compressed.js'></script>
//<script type="text/javascript" src="js/arraySplice.js"></script>

$idSubmitted = $_GET["id"];

$results = mysql_query("select * from specimen where id=$idSubmitted order by id");
$row = @ mysql_fetch_array($results);

$nameSpecimen = $row["name"];
$idSpecimen = $row["id"];
$pathSpecimen = $row["path"];
$sizeXSpecimen = $row["size_x"];
$sizeYSpecimen = $row["size_y"];

$roiFindingParam1 = $row["roi_finding_param1"];
$roiFindingParam2 = $row["roi_finding_param2"];
$roiFindingParam3 = $row["roi_finding_param3"];
$roiFindingParam4 = $row["roi_finding_param4"];


$results = mysql_query("select * from regions where id_specimen=$idSpecimen and id_user=".$_SESSION["userid"]." order by id");

while ($row = @ mysql_fetch_array($results)) 
{
  $regionsX[] = $row["x"];
  $regionsY[] = $row["y"];
  $regionsId[] = $row["id"];
  $regionsState[] = $row["state"];  
}

//------------------------------------------------------------
$results = mysql_query("select * from work_collections where id_specimen=$idSpecimen order by id");

$i = 0;
while ($row = @ mysql_fetch_array($results)) 
{
  $idWorkCollection = $row["id"];
  $nameWorkCollection = $row["name"];
  $pathWorkCollection = $row["path"];
  
  //$filterResultsName[] = $row["name"];
  //$filterResultsPath[] = $row["path"];
  
  $workCollectionNames[] = $nameWorkCollection;
  $workCollectionPaths[] = $pathWorkCollection;  
  
  $results2 = mysql_query("select * from filter_results where id_work_collection=$idWorkCollection order by name");
  
  while ($row2 = @ mysql_fetch_array($results2)) 
  {
    $filterResultsName[] = $row2["name"];
    //$filterResultsPath[] = $pathWorkCollection."filter_results/".$row2["path"];
    $filterResultsPath[] = $row2["path"];
    $filterResultsWorkCollection[] = $i;
    //$workCollection[]
    
    
    
  }
  $i++;  
}


//$results = mysql_query("select * from filter_results where id_specimen=$idSpecimen order by id");
//
//while ($row = @ mysql_fetch_array($results)) 
//{
//  $filterResultsName[] = $row["name"];
//  $filterResultsPath[] = $row["path"];
//}

//------------------------------------------------------------

echo "<script language=\"javascript\">\n";

if(sizeof($regionsX)==1)
{
  echo "var regionsX = new Array();\n";
  echo "regionsX[0] = $regionsX[0];\n";

  echo "var regionsY = new Array();\n";
  echo "regionsY[0] = $regionsY[0];\n";

  echo "var regionsId = new Array();\n";
  echo "regionsId[0] = $regionsId[0];\n";

  echo "var regionsState = new Array();\n";
  echo "regionsState[0] = $regionsState[0];\n";

}
else
{
  echo "var regionsX = new Array(" . implode(", ", $regionsX) . ");\n";
  echo "var regionsY = new Array(" . implode(", ", $regionsY) . ");\n";
  echo "var regionsId = new Array(" . implode(", ", $regionsId) . ");\n";
  echo "var regionsState = new Array(" . implode(", ", $regionsState) . ");\n";  
}

if(sizeof($filterResultsName)==1)
{
  echo "var filterResultsName = new Array();\n";
  echo "filterResultsName[0] = '$filterResultsName[0]';\n";

  echo "var filterResultsPath = new Array();\n";
  echo "filterResultsPath[0] = '$filterResultsPath[0]';\n";

  echo "var filterResultsWorkCollection = new Array();\n";
  echo "filterResultsWorkCollection[0] = $filterResultsWorkCollection[0];\n";
}
else
{
  echo "var filterResultsName = new Array('" . implode("', '", $filterResultsName) . "');\n";
  echo "var filterResultsPath = new Array('" . implode("', '", $filterResultsPath) . "');\n";
  echo "var filterResultsWorkCollection = new Array(" . implode(", ", $filterResultsWorkCollection) . ");\n";  
}

if(sizeof($workCollectionNames)==1)
{
  echo "var workCollectionNames = new Array();\n";
  echo "workCollectionNames[0] = '$workCollectionNames[0]';\n";

  echo "var workCollectionPaths = new Array();\n";
  echo "workCollectionPaths[0] = '$workCollectionPaths[0]';\n";
}
else
{
  echo "var workCollectionNames = new Array('" . implode("', '", $workCollectionNames) . "');\n";
  echo "var workCollectionPaths = new Array('" . implode("', '", $workCollectionPaths) . "');\n";
}
  
echo "var baseImageUrl = '$pathSlideDataServer$pathSpecimen/'; ";
echo "var idSpecimen = $idSpecimen;\n";
echo "var specimenSizeX = $sizeXSpecimen;\n";
echo "var specimenSizeY = $sizeYSpecimen;\n";
echo "var roiFindingParam1 = $roiFindingParam1;\n";
echo "var roiFindingParam2 = $roiFindingParam2;\n";
echo "var roiFindingParam3 = $roiFindingParam3;\n";
echo "var roiFindingParam4 = $roiFindingParam4;\n";
echo "</script>";

?>

<body>
<div id="container">
	<?php include("header.php"); ?>
	<div id="inner_container">
    <div id="page_title">
       	  
            <h1>Specimen <?php echo $nameSpecimen ?></h1>
            <div style="clear:both"></div>	
            <hr />
      </div>
    <div id="sidebar">
        <ul><h3>
              <li ><a title="Back" href="list_available_specimen.php">Back</a></li>
        </h3></ul>
      <div class="sideitem">
      <h3>Markers to be shown and used within computation</h3>
        <table border="0" cellspacing="5" cellpadding="5">
          <tr>
            <td align="left"><input type="checkbox" name="autogencheckbox" id="autogencheckbox" onclick="autogenCheckboxToggled()"/></td>
            <td align="left">Automatically generated</td>
          </tr>
          <tr>
            <td align="left"><input type="checkbox" name="confirmedcheckbox" id="confirmedcheckbox" onclick="confirmedCheckboxToggled()"/></td>
            <td align="left">Confirmed</td>
          </tr>
          <tr>
            <td align="left"><input type="checkbox" name="manualcheckbox" id="manualcheckbox" onclick="manualCheckboxToggled()"/></td>
            <td align="left">Manually generated</td>
          </tr>          
        </table>  
        <a href="#" onclick="toogleText(1)"> Some help..</a>     
      <p style="display : none" id="toogletext1">Choose which markers to show. Manually positioned markers, markers generated by the region finding algorithm, and markers that were manually confirmed.</p>      
      </div>
      
<?php 
if($u_up)
{
?>      
    <div class="sideitem">
      <h3>Region finding</h3>
        <table border="0" cellspacing="5" cellpadding="5">
          <tr>
            <td align="left">Min:  </td>
            <td align="left"><input type="text" name="param1" id="param1" size="6" maxlength="4" /></td>
          </tr>
          <tr>
            <td align="left">Max:  </td>
            <td align="left">  <input type="text" name="param2" id="param2" size="6" maxlength="4" /></td>
          </tr>
          <tr>
            <td/>
            <td align="left"><input type="button" name="computeregions" id="computeregions" value="Compute" OnClick="computeRegions();"></td>
          </tr>
        </table>      
      <a href="#" onclick="toogleText(2)"> Some help..</a>     
      <p style="display : none" id="toogletext2">Min/Max: the minimal/maximal percentage of pixels that have to be foreground in a region to be detected. As the regions are predetermined by a tiling, the centers of the regions often ly somewhat different from the expected center.</p>
    </div>
  <?php 
  if($u_ua)
  {
  ?>      
    <div class="sideitem">
    <h3>Nuclei detection</h3>
      <input type="button" name="findnuclei" id="findnuclei" value="Compute ATh" OnClick="findNuclei();">
      <br/>
      <input type="button" name="importcollection" id="importcollection" value="Import Collection" OnClick="importCollection();">
      <br/>
      <a href="#" onclick="toogleText(3)"> Some help..</a>     
    <p style="display : none" id="toogletext3">Find nuclei in the specified regions of interest. </p>
    </div>
<?php 
    //      <a href="gui_find_nuclei_in_rois.php?id_specimen=<?php echo $idSpecimen "> Start algorithm</a>
  }
}
?>      


        
	</div>
	<div id="content">      
		<div id="map" ></div>
  </div>
</div>
</div>
</body>
</html>
