<?php 
  session_start(); 

/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/
 
  require("auth_and_connect.php");

  error_reporting(E_ALL);
  ini_set('display_errors', '1');

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Add specimen</title>
<link href="css/css_base.css" rel="stylesheet" type="text/css" />

<script type="text/javascript" src="js/prototype/prototype.js"></script>
<script type="text/javascript" src="js/bramus/jsProgressBarHandler.js"></script>

<?php
//<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;sensor=false&amp;key=ABQIAAAAVMetj7hM2P0Ow845ErQ8aRQjUacBjyfBSHMpgOe5xbXtcDyKIBTTDjc8HHrH3UCHRWe0KDLJp0yLFg" 
//type="text/javascript"></script>

//  if (isset($_POST["process"]))
//  {
//    <script type="text/javascript">
//    
//    window.onload = startProcessing;
//    
//    function startProcessing() 
//    {
//      var result = GDownloadUrl('phpsql_proc_incoming.php', 
//          function (data,response) {
//              //window.location.reload();
//              GLog.write(data);
//            });
//    }
//    
//    </script>
//  }
?>  

</head>
<body>
<div id="container">
	<?php include("header.php"); ?>
	<div id="inner_container">
    <div id="page_title">
       	  <h1>Process Incoming Folder</h1>
            <div style="clear:both"></div>	
            <hr />
      </div>
    <div id="sidebar">
        <ul><h3>
              <li ><a title="Back" href="list_available_specimen.php">Back</a></li>
        </h3></ul>
	</div>      
	<div id="content">   
  

<?php

function ends_with($string, $endstr)
{
    $string_end = substr($string, strlen($string) - strlen($endstr));
    //return $string_end == $endstr;
    return (strncmp($string_end, $endstr, strlen($endstr)) == 0);
}

if (isset($_POST["process"]))
{
  echo "processing files started..</br>";
  echo shell_exec("php scripts/phpsql_proc_incoming.php > $localDocumentRoot/log/log_proc_incoming.txt &");
}
else
{

  $state = -2;
  $stateFileName = "$pathIncomingFiles.state";
  $stateFileHandle = fopen($stateFileName, "r");
  
  if($stateFileHandle)
  {
    $stateFileContent = fread($stateFileHandle, filesize($stateFileName));
    fclose($stateFileHandle);
    
    $state = $stateFileContent + 0;
  }
  else
  {
    $fh = fopen($stateFileName, 'w');
    fwrite($fh, "-1"); 
    fclose($fh);
    $state = -1;
  }
  
  if($state == -1)
  {   
    ?>  
    <table width='95%' border='0'>
    <tr bordercolor='#101010' bgcolor='#f0f0f0'>
      <td><b>Filename</b></td>
      <td><b>Filesize</b></td>
      </tr>  
    <?php
      
      $dirHandle = @opendir($pathIncomingFiles) or die("Unable to open $pathIncomingFiles"); 
      
      while ($file = readdir($dirHandle)) 
      {
        if(!ends_with($file,".svs") && !ends_with($file,".SVS")) continue;
        $filePath = "$pathIncomingFiles$file";
        $filesize = filesize ( $filePath );
    
        echo "<tr>";
        echo "<td width='50%'><b>$file</b><br></td>";
        echo "<td width='50%'><b>$filesize</b><br></td>";
        echo "</tr>";      
    
      } 
    
      closedir($dirHandle);
        
    ?>
    </table>
    <div id="form" align="center">
      <form action="" method="post" enctype="multipart/form-data" name="form1" id="form1">
        <input type="submit" name="process" id="process" value="Move these files From incoming to storage folder and start tiling.." />
      </form>
    </div>
    
    <?php
  }
  else 
  {
    echo "Operation yet in progress:</br>\n";
    echo "<span class=\"progressBar\" id=\"progress1\">$state%</span>";
  }
  
}
?>

</div>
</div>
</div>
</body>
</html>
