<?php session_start();

/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

require("auth_and_connect.php");
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Available Specimen</title>
<link href="css/css_base.css" rel="stylesheet" type="text/css" />

<script type="text/javascript" src="js/prototype/prototype.js"></script>

<script type="text/javascript">
function showEditor(idSpecimen) 
{ 
    document.getElementById('comment' + idSpecimen).readOnly=false;
    document.getElementById('comment' + idSpecimen).style.color = "#1e329b";
    //document.getElementById('comment' + idSpecimen).style.color = "#D68862";    
} 

function saveComment(idSpecimen) 
{ 
  var currentComment = document.getElementById('comment' + idSpecimen).value;
  var params = "id_specimen=" + idSpecimen + "&comment=" + currentComment;

  //GLog.write('idSpecimen: ' + idSpecimen + ' comment: ' + currentComment);    
  //GLog.write(params);
    
  new Ajax.Request('phpsql_edit_comment.php', { method:'post' , 
                                                parameters: params
  });

//                                                onSuccess: function(transport)
//                                                             {
//                                                               var response = transport.responseText || "no response text";
//                                                               alert("Success! \n\n" + response);
//                                                             },
//                                                onFailure: function(){ alert('Something went wrong...') }
                                                    
  document.getElementById('comment' + idSpecimen).readOnly=true;
  document.getElementById('comment' + idSpecimen).style.color = "#000";  
} 
</script>

<style type="text/css">
textarea {
  overflow: auto;
  border: none;
  background-color: #d0d0e0;  
}
</style>
    
</head>

<body>

<div id="container">

<?php include("header.php"); ?>

<div id="inner_container">
 <div id="page_title">
  <h1>Available Specimens</h1>
  <h2>Welcome <?echo $_SESSION['username'];?></h2>
  <div style="clear:both"></div>	
  <hr/>
 </div>

<?php 
if ($u_ua)
{
?>
 <div id="sidebar">
   <ul>
   <h3>
    <li ><a title="Add Specimen Data" href="gui_add_specimen.php">Add Specimen Data</a></li>
    <li ><a title="Modify Specimen Data" href="gui_modify_specimen.php">Modify Specimen Data</a></li>
    <li ><a title="Process Incoming Folder" href="gui_proc_incoming.php">Process Incoming Folder</a></li>
   </h3>
   </ul>
 </div>

<?php 
}
?>
 
 <div id="content">
 <div>
 
<?php

//print "user_id:" . $_SESSION["userid"] . "<br/>";

$results = mysql_query("select * from specimen order by name");

//$total_registros = @ mysql_num_rows($resultados);
//$resultados = mysql_query("select * from muestras order by id DESC LIMIT $inicio, $registros");
//$total_páginas = ceil($total_registros / $registros);

//echo "<center><h2><b>Listado de las muestras</b></h2>";

echo "<table width='95%' border='0'>";
echo "<tr bordercolor='#101010' bgcolor='#f0f0f0'>
	<td><b>SL</b></td>
	<td><b>Image</b></td>
  <td><b>Code</b></td>
	<td><b>Comment</b></td>
  <td><b>Edit</b></td>
  <td><b>Name</b></td>
  <td><b>Date</b></td>
	</tr>
	";

if ($u_ua) echo "<form action=\"gui_delete_specimen.php\" method=\"post\"> \n";
while ($row = mysql_fetch_array($results)) {
	echo "<tr>";
  if ($u_ua) echo "<td width='5%'><input type=\"checkbox\" name=\"selection[]\" value=\"" . $row['id'] . "\"><br></td>"; else echo "<td/>";
	echo "<td width='20%'><a href=\"gui_image_viewer.php?id=$row[id]\">";
  echo "<img src='$pathSlideDataServer$row[path]/$row[path]$postfixThumbnail' width='150'></a></td>";
  if ($u_up) echo "<td width='20%'><img src='$pathSlideDataServer$row[path]/$row[path]$postfixCode' width='150'></td>"; else echo "<td/>";
	if ($u_up) echo "<td width='20%'><b><textarea name=\"comment$row[id]\" cols=\"34\" rows=\"10\" id=\"comment$row[id]\" READONLY>$row[comment]</textarea></b><br></td>"; else echo "<td/>";
  if ($u_up) echo "<td width='10%'><a href=\"#\" onclick=\"showEditor($row[id])\">Edit Comment...</a><br/><a href=\"#\" onclick=\"saveComment($row[id])\">Save Comment...</a></td>"; else echo "<td/>";
  echo "<td width='10%'><b>$row[name]</b><br></td>";
  echo "<td width='10%'><b>$row[date]</b><br></td>";
  echo "</tr>";
}
if ($u_ua)echo "<input type=\"submit\" name=\"submit\" value=\"Delete\">";
if ($u_ua) echo "</form>";
echo "</table>";
//-------------------------------------------------------------------------------------------------------------
// <a href="imagenes_originales.php?id=<?php echo $fila["id"]
?>
 
  <div style="clear:both"></div>
 </div> 
 
<?php
//echo "<div align=\"center\">";
//echo "<p>";
//if (($página -1) > 0) {
//	echo "<a href='muestras_disponibles.php?página=" . ($página -1) . "'>< Anterior</a> ";
//}
//for ($i = 1; $i <= $total_páginas; $i++) {
//	if ($página == $i)
//		echo "<b>" . $página . "</b> ";
//
//	else {
//		echo "<a href='muestras_disponibles.php?página=$i'>$i</a> ";
//	}
//}
//if (($página +1) <= $total_páginas) {
//	echo " <a href='muestras_disponibles.php?página=" . ($página +1) . "'>Siguiente ></a>";
//}
//echo "</div>";
?> 

 </div>
</div>
</body>
</html>
