<?php 

/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

require("connect.php");
require ("process_large_image.php");

$idSpecimen = 0 + $argv[1];
$pathSpecimen = $argv[2]; //e.g. $pathSpecimen = 6671_jpeg

$idWorkCollection = 0 + $argv[3];
$pathWorkCollection = $argv[4]; //e.g. "PRN/"

$dirHandle = @opendir($pathIncomingCollections) or die("Unable to open $pathIncomingCollections"); 

$presentDirectories = array();

while (false !== ($file = readdir($dirHandle))) 
{
  if($file == "." || $file == "..") continue;
  if(is_dir("$pathIncomingCollections$file")) $presentDirectories[] = $file;
  echo "$file\n";
}

$fullTiffFilename = "$pathSlideData$pathSpecimen/$pathSpecimen$postfixFullSlide";

$pathWorkCollections = "$pathSlideData$pathSpecimen/work_collections/";
$pathCurrentWorkCollection = "$pathWorkCollections$pathWorkCollection";
$pathFilterResults = $pathCurrentWorkCollection . "filter_results/";

shell_exec(str_replace($separatorNot, $separator, "mkdir $pathFilterResults"));

echo "TestyXX\n";

for($i=0;$i<sizeof($presentDirectories);$i++)
{
  echo "Testy $i\n";
  
  $pathCurrentFilterResult = "$pathFilterResults$presentDirectories[$i]/";
  
  echo "mv $pathIncomingCollections$presentDirectories[$i] $pathCurrentFilterResult";
  
  echo shell_exec ("mv $pathIncomingCollections$presentDirectories[$i] $pathCurrentFilterResult");
  
  bp_apply_filter($pathCurrentFilterResult, "cvRectBorder");
  
  $pathInsertRegions = $pathCurrentFilterResult."cvRect/";
  
  $pathTiles = $pathCurrentFilterResult . "tiles/";     

  generateTiles($fullTiffFilename, $pathTiles, true, false, $pathInsertRegions, true, true, true);

  $query = "INSERT INTO filter_results(id, id_work_collection, name, date, comment, path, parameters) VALUES (NULL , '$idWorkCollection', '$presentDirectories[$i]', '" . 
                                                              date('Y-m-d') . "', '', '$presentDirectories[$i]/', '')";
  print $query;
  
  $result=mysql_query($query);
  if(mysql_errno($connection)==0)
  {
    print "Dataset was inserted</br>";
  }
  else
  {
    if(mysql_errno($connection)==1062)
      print "Double primary key, couldn't insert</br>";
    else
    {
      $numERROR=mysql_errno($connection);
      $description=mysql_errno($connection);
      print "An error occured: $numERROR Description: $description </br>";
    };
  }
}

?>
