<?php //session_start();

/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

require("connect.php");
require ("process_large_image.php");

//function ends_with($string, $endstr)
//{
//    $string_end = substr($string, strlen($string) - strlen($endstr));
//    return (strncmp($string_end, $endstr, strlen($endstr)) == 0);
//}
  
$dirHandle = @opendir($pathIncomingFiles) or die("Unable to open $pathIncomingFiles"); 

while ($file = readdir($dirHandle)) 
{
  if(!ends_with($file,".svs") && !ends_with($file,".SVS")) continue;
  else $svsFiles[] = $file;
  //echo "$file\n";
}
  
//print_r($svsFiles);
  
for($i=0;$i<sizeof($svsFiles);$i++)
{      
  $progress = round(($i / sizeof($svsFiles)) * 100);

  //echo "$progress";
  //print($svsFiles[$i]);
    
  $fh = fopen("$pathIncomingFiles.state", 'w') or die("can't open state file for writing: $pathIncomingFiles.state");
  fwrite($fh, "$progress");  
  fclose($fh);    
    
  $filePath = "$pathSlideData$svsFiles[$i]";
  $filePathNoEnding = substr($filePath, 0, -4);
  $fileNameNoEnding = substr($svsFiles[$i], 0, -4);
    
  shell_exec("cp $pathIncomingFiles$svsFiles[$i] $pathSlideData$svsFiles[$i]");
    
  //$commandline = "php cl_process_large_image.php --inSvsFile=$filePath --writeTilesTo=$filePathNoEnding/tiles/";
  
  $fullTiffFilename = splitSvsImage($filePath);
  generateTiles($fullTiffFilename, "$filePathNoEnding/tiles/");

  $fullTiffFileName = "$filePathNoEnding/$fileNameNoEnding$postfixFullSlide";
    
  $imgSizeX = shell_exec("vips im_header_int Xsize $fullTiffFileName"); 
  $imgSizeY = shell_exec("vips im_header_int Ysize $fullTiffFileName"); 
  
  $query = "INSERT INTO specimen(id, name, date, comment, path, size_x, size_y) VALUES (NULL , '$fileNameNoEnding', '" . 
                                                            date('Y-m-d') . "', '', '$fileNameNoEnding', $imgSizeX, $imgSizeY)";
  print $query."</br>";
  $result=mysql_query($query);
  if(mysql_errno($connection)==0)
  {
    print "Dataset was inserted</br>";
  }
  else
  {
    if(mysql_errno($connection)==1062)
      print "Double primary key, couldn't insert</br>";
    else
    {
      $numERROR=mysql_errno($connection);
      $description=mysql_errno($connection);
      print "An error occured: $numERROR Description: $description </br>";
    };
  }    
} 

closedir($dirHandle);

$fh = fopen("$pathIncomingFiles.state", 'w') or die("can't open state file for writing..");
fwrite($fh, "-1");  
fclose($fh);

?>
